﻿Public Class BooksCollections
    Inherits Collections.CollectionBase

    
    Private _Nome As String


    Default Public Property Item(ByVal index As Integer) As Book
        Get
            Return CType(List(index), Book)
        End Get
        Set(ByVal value As Book)
            List(index) = value
        End Set
    End Property

    Public Property Nome() As String
        Get
            Return _Nome
        End Get
        Set(ByVal value As String)
            _Nome = value
        End Set
    End Property


    Public Function Add(ByVal value As Book) As Integer
        Return List.Add(value)
        Return List.Count
    End Function 'Add

    Public Function IndexOf(ByVal value As Book) As Integer
        Return List.IndexOf(value)
    End Function 'IndexOf


    Public Sub Insert(ByVal index As Integer, ByVal value As Book)
        List.Insert(index, value)
    End Sub 'Insert


    Public Sub Remove(ByVal value As Book)
        List.Remove(value)
    End Sub 'Remove


    Public Function Contains(ByVal value As Book) As Boolean
        ' If value is not of type Int16, this will return false.
        Return List.Contains(value)
    End Function 'Contains


    Protected Overrides Sub OnInsert(ByVal index As Integer, ByVal value As Object)
        ' Insert additional code to be run only when inserting values.
    End Sub 'OnInsert


    Protected Overrides Sub OnRemove(ByVal index As Integer, ByVal value As Object)
        ' Insert additional code to be run only when removing values.
    End Sub 'OnRemove


    Protected Overrides Sub OnSet(ByVal index As Integer, ByVal oldValue As Object, ByVal newValue As Object)
        ' Insert additional code to be run only when setting values.
    End Sub 'OnSet


    Protected Overrides Sub OnValidate(ByVal value As Object)
        If Not GetType(Book).IsAssignableFrom(value.GetType()) Then
            Throw New ArgumentException("value must be of type Book.", "value")
        End If
    End Sub 'OnValidate

    Public Sub New()

    End Sub
    Public Sub New(ByVal Nome As String)
        _Nome = Nome
    End Sub
End Class
